Public Class ExampleForm
    Protected _strGen1Freq As String = "1000"
    Protected _strGen1Depth As String = "30"
    Protected _strGen2Freq As String = "1000"
    Protected _nGen2Shape As Integer = 0
    Protected _strGen2Rise As String = "1e-6"
    Protected _strGen2Fall As String = "1e-6"
    Protected _strGen2High As String = "1e-6"
    Protected _strGen2Low As String = "1e-6"
    Protected _nNoiseDistribution As Integer = 0
    Protected _bNoiseBandWidthState As Boolean = False
    Protected _strNoiseBandWidth As String = "100000"


    Private Sub exitBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles exitBtn.Click
        If MessageBox.Show("Are you sure you want to quit?", "Quit", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
            Close()
        End If
    End Sub

    Private Sub ExampleForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        _source.SelectedIndex = 0
    End Sub

    Private Sub apply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles apply.Click
        Dim sma As rssma
        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
            sma = New rssma(resourceDescriptor.Text, idQuery.Checked, resetDevice.Checked)
        Catch ex As Exception
            Dim message As String

            message = "Instrument Status Error: "
            message += ex.Message
            MessageBox.Show(message)
            System.Windows.Forms.Cursor.Current = Cursors.Arrow
            UseWaitCursor = False
            Return
        End Try

        Try
            sma.confRFFreq(Decimal.ToDouble(_rfFrequency.Value), 0.0, False, 0.0)
            sma.confRFLevel(Decimal.ToDouble(_rfLevel.Value), 0.0, 30.0, False, 0.0, rssmaConstants.OutputAmodeAuto, rssmaConstants.PowerLevelRclExclude)

            Dim nSource = _source.SelectedIndex

            If (nSource <> 0) Then
                Dim dGen1Depth = Convert.ToDouble(_strGen1Depth)
                Dim dGen1Freq = Convert.ToDouble(_strGen1Freq)
                Dim dGen2Freq = Convert.ToDouble(_strGen2Freq)
                sma.configAM(_state.Checked, rssmaConstants.AmSourceInt, Decimal.ToDouble(_depth.Value), rssmaConstants.AmExternalCouplingAc, nSource - 1, dGen1Depth, dGen1Freq, _nGen2Shape, dGen2Freq)

                If (nSource = 1 Or nSource = 3 Or nSource = 5) Then    ' LF Gen 1                     
                    sma.confLFFreq(True, 1, dGen1Freq, 1.0)
                End If

                If (nSource = 2 Or nSource = 3 Or nSource = 6) Then 'LF Gen 2                     
                    sma.confLFFreq(True, 2, dGen2Freq, 1.0)
                    sma.SetLFGenShape(_nGen2Shape)
                    If (_nGen2Shape = 3) Then ' trapeze
                        Dim dGen2Fall = Convert.ToDouble(_strGen2Fall)
                        Dim dGen2Rise = Convert.ToDouble(_strGen2Rise)
                        Dim dGen2High = Convert.ToDouble(_strGen2High)
                        Dim dGen2Low = Convert.ToDouble(_strGen2Low)
                        sma.SetLFGenShapeTrapeze(rssmaConstants.LfoutputShapeTrapezeFall, dGen2Fall)
                        sma.SetLFGenShapeTrapeze(rssmaConstants.LfoutputShapeTrapezeRise, dGen2Rise)
                        sma.SetLFGenShapeTrapeze(rssmaConstants.LfoutputShapeTrapezeHigh, dGen2High)
                        sma.SetLFGenShapeTrapeze(rssmaConstants.LfoutputShapeTrapezeLow, dGen2Low)
                    End If
                End If
                If (nSource = 4 Or nSource = 5 Or nSource = 6) Then ' // Noise                
                    Dim dNoiseBandWidth = Convert.ToDouble(_strNoiseBandWidth)
                    sma.confNoise(_bNoiseBandWidthState, dNoiseBandWidth, _nNoiseDistribution)
                End If
            Else
                sma.SetAMSource(rssmaConstants.AmSourceInt)
                sma.SetAMDepth(Decimal.ToDouble(_depth.Value))
                sma.SetAMState(_state.Checked)
            End If

            sma.SetOutputState(_rfState.Checked)

        Catch ex As Exception
            Dim message As String
            Dim code As Integer
            Dim errQuery As New System.Text.StringBuilder(256)

            message = "Instrument Status Error: "
            sma.error_query(code, errQuery)
            message += ex.Message + vbCrLf + errQuery.ToString
            MessageBox.Show(message)
        End Try
        System.Windows.Forms.Cursor.Current = Cursors.Arrow
        UseWaitCursor = False
    End Sub

    Private Sub OnSourceChange(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _source.SelectedIndexChanged
        Dim bGen1 As Boolean = False
        Dim bGen2 As Boolean = False
        Dim bNoise As Boolean = False

        Select Case _source.SelectedIndex

        End Select

    End Sub

    Private Sub OnGen1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _gen1.Click
        Dim dlg As New DlgGen1()

        dlg.Freq = _strGen1Freq
        dlg.Depth = _strGen1Depth

        If (dlg.ShowDialog() = DialogResult.OK) Then
            _strGen1Freq = dlg.Freq
            _strGen1Depth = dlg.Depth
        End If

    End Sub

    Private Sub OnGen2(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _gen2.Click
        Dim dlg = New DlgGen2()

        dlg.Freq = _strGen2Freq
        dlg.Shape = _nGen2Shape
        dlg.Rise = _strGen2Rise
        dlg.Fall = _strGen2Fall
        dlg.High = _strGen2High
        dlg.Low = _strGen2Low

        If (dlg.ShowDialog() = DialogResult.OK) Then
            _strGen2Freq = dlg.Freq
            _nGen2Shape = dlg.Shape
            _strGen2Rise = dlg.Rise
            _strGen2Fall = dlg.Fall
            _strGen2High = dlg.High
            _strGen2Low = dlg.Low
        End If
    End Sub

    Private Sub OnNoise(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _noise.Click
        Dim dlg = New DlgNoise()

        dlg.Distribution = _nNoiseDistribution
        dlg.BandWidthState = _bNoiseBandWidthState
        dlg.BandWidth = _strNoiseBandWidth

        If (dlg.ShowDialog() = DialogResult.OK) Then
            _nNoiseDistribution = dlg.Distribution
            _bNoiseBandWidthState = dlg.BandWidthState
            _strNoiseBandWidth = dlg.BandWidth
        End If
    End Sub
    Private Sub OnChangeSource(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _source.SelectedIndexChanged
        Dim bGen1 As Boolean = False
        Dim bGen2 As Boolean = False
        Dim bNoise As Boolean = False

        Select Case _source.SelectedIndex
            Case 1  'Gen 1
                bGen1 = True
            Case 2  'Gen 2
                bGen2 = True
            Case 3  'Gen 1 + 2
                bGen1 = True
                bGen2 = True
            Case 4  'Noise
                bNoise = True
            Case 5  'Gen 1 + Noise
                bGen1 = True
                bNoise = True
            Case 6  'Gen 2 + Noise
                bGen2 = True
                bNoise = True
        End Select

        _gen1.Enabled = bGen1
        _gen2.Enabled = bGen2
        _noise.Enabled = bNoise

    End Sub
End Class
