Public Class ExampleForm

    Private Sub ExampleForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        fmExtCoupling.SelectedIndex = 0
        fmMode.SelectedIndex = 0
        extImpedance.SelectedIndex = 0
    End Sub

    Private Sub exitBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles exitBtn.Click
        If MessageBox.Show("Are you sure you want to quit?", "Quit", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
            Close()
        End If
    End Sub

    Private Sub apply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles apply.Click
        Dim sma As rssma
        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
            sma = New rssma(resourceDescriptor.Text, idQuery.Checked, resetDevice.Checked)
        Catch ex As Exception
            Dim message As String

            message = "Instrument Status Error: "
            message += ex.Message
            MessageBox.Show(message)
            System.Windows.Forms.Cursor.Current = Cursors.Arrow
            UseWaitCursor = False
            Return
        End Try

        Try
            sma.confPM(fmState.Checked, rssmaConstants.FmSourceExternal, fmMode.SelectedIndex, Decimal.ToDouble(fmExtDeviation.Value), 0.5, Decimal.ToDouble(fmExtDeviation.Value), fmExtCoupling.SelectedIndex, extImpedance.SelectedIndex, rssmaConstants.FmExternalDigitalFormatBoffset)


            sma.confRFFreq(Decimal.ToDouble(rfFrequency.Value), 0.0, False, 0.0)
            sma.confRFLevel(Decimal.ToDouble(rfLevel.Value), 0.0, 30.0, False, 0.0, rssmaConstants.OutputAmodeAuto, rssmaConstants.PowerLevelRclExclude)
            sma.SetOutputState(rfState.Checked)
        Catch ex As Exception
            Dim message As String
            Dim code As Integer
            Dim errQuery As New System.Text.StringBuilder(256)

            message = "Instrument Status Error: "
            sma.error_query(code, errQuery)
            message += ex.Message + vbCrLf + errQuery.ToString
            MessageBox.Show(message)
        End Try
        System.Windows.Forms.Cursor.Current = Cursors.Arrow
        UseWaitCursor = False
    End Sub
End Class
