Public Class ExampleForm

    Private Sub exitBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles exitBtn.Click
        If MessageBox.Show("Are you sure you want to quit?", "Quit", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
            Close()
        End If
    End Sub

    Private Sub ExampleForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        _mode.SelectedIndex = 0
        _slope.SelectedIndex = 0
    End Sub

    Private Sub apply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles apply.Click
        Dim sma As rssma
        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
            sma = New rssma(resourceDescriptor.Text, idQuery.Checked, resetDevice.Checked)

            Dim strDirectory = _directory.Text

            Dim nIndex = _list.SelectedIndex
            If (nIndex <> -1) Then
                Dim strItem = _list.SelectedText

                Dim strName As String = strDirectory + "\" + strItem

                sma.SetLISTSelectList(strName)

                sma.SetLISTMode(_mode.SelectedIndex)
                sma.SetLISTDwellTime(Decimal.ToDouble(_time.Value))

                Select Case _mode.SelectedIndex
                    Case 1  ' Single
                    Case 3  ' Extern step
                    Case 5  ' Extern hop
                        sma.SetInstrumentTriggerInputSlope(_slope.SelectedIndex)
                End Select

            End If

            sma.SetOutputState(_rfState.Checked)


        Catch ex As Exception
            Dim message As String

            message = "Instrument Status Error: "
            message += ex.Message
            MessageBox.Show(message)
            System.Windows.Forms.Cursor.Current = Cursors.Arrow
            UseWaitCursor = False
            Return
        End Try

        Try
        Catch ex As Exception
            Dim message As String
            Dim code As Integer
            Dim errQuery As New System.Text.StringBuilder(256)

            message = "Instrument Status Error: "
            sma.error_query(code, errQuery)
            message += ex.Message + vbCrLf + errQuery.ToString
            MessageBox.Show(message)
        End Try
        System.Windows.Forms.Cursor.Current = Cursors.Arrow
        UseWaitCursor = False
    End Sub

    Private Sub OnModeChange(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _mode.SelectedIndexChanged
        Dim nIndex = _mode.SelectedIndex

        _slope.Enabled = nIndex >= 3 And nIndex <= 5
    End Sub

    Private Sub OnFillList(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim sma As rssma
        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
            sma = New rssma(resourceDescriptor.Text, idQuery.Checked, resetDevice.Checked)

            _list.Items.Clear()

            Dim strDirectory = _directory.Text

            If (strDirectory <> "") Then
                sma.MMEMoryChangeDirectory(strDirectory)
            End If


            Dim catalogList = New System.Text.StringBuilder()
            sma.LISTCatalog("", 255, catalogList)

            Dim strText = catalogList.ToString()
            Dim strParts() As String = strText.Split(",")

            _list.Items.Clear()
            Dim strPart As String
            For Each strPart In strParts
                _list.Items.Add(strPart)
            Next


        Catch ex As Exception
            Dim message As String
            Dim code As Integer
            Dim errQuery As New System.Text.StringBuilder(256)

            message = "Instrument Status Error: "
            sma.error_query(code, errQuery)
            message += ex.Message + vbCrLf + errQuery.ToString
            MessageBox.Show(message)

        End Try
        System.Windows.Forms.Cursor.Current = Cursors.Arrow
        UseWaitCursor = False

    End Sub
End Class
