Public Class ExampleForm
    Protected _nTriggerMode As Integer = 0
    Protected _nTriggerSlope As Integer = 0
    Protected _nTriggerPolarity As Integer = 0
    Protected _strDoublePulseWidth As String = "1e-3"
    Protected _strDoublePulseDelay As String = "1e-3"



    Private Sub ExampleForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    End Sub

    Private Sub exitBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles exitBtn.Click
        If MessageBox.Show("Are you sure you want to quit?", "Quit", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
            Close()
        End If
    End Sub

    Private Sub apply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles apply.Click
        Dim sma As rssma
        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
            sma = New rssma(resourceDescriptor.Text, idQuery.Checked, resetDevice.Checked)


            sma.confRFFreq(Decimal.ToDouble(_rfFrequency.Value), 0.0, False, 0.0)
            sma.confRFLevel(Decimal.ToDouble(_rfLevel.Value), 0.0, 30.0, False, 0.0, rssmaConstants.OutputAmodeAuto, rssmaConstants.PowerLevelRclExclude)

            Dim dDoublePulseWidth = Convert.ToDouble(_strDoublePulseWidth)
            Dim dDoublePulseDelay = Convert.ToDouble(_strDoublePulseDelay)
            sma.confPulm(_state.Checked, rssmaConstants.PulmSourceInternal, rssmaConstants.PulmPolarityNormal, _pulseState.Checked, Decimal.ToDouble(_period.Value), Decimal.ToDouble(_width.Value), Decimal.ToDouble(_delay.Value), _doublePulseState.Checked, dDoublePulseWidth, dDoublePulseDelay, _nTriggerMode)

            Select Case _nTriggerMode
                Case 1 ' Ext Triggered
                    sma.SetInstrumentTriggerInputSlope(_nTriggerSlope)
                Case 2 ' Ext Gated
                    sma.SetInstrumentTriggerInputSlope(_nTriggerPolarity)
            End Select

            sma.SetOutputState(_rfState.Checked)


        Catch ex As Exception
            Dim message As String

            message = "Instrument Status Error: "
            message += ex.Message
            MessageBox.Show(message)
            System.Windows.Forms.Cursor.Current = Cursors.Arrow
            UseWaitCursor = False
            Return
        End Try

        Try
            

        Catch ex As Exception
            Dim message As String
            Dim code As Integer
            Dim errQuery As New System.Text.StringBuilder(256)

            message = "Instrument Status Error: "
            sma.error_query(code, errQuery)
            message += ex.Message + vbCrLf + errQuery.ToString
            MessageBox.Show(message)
        End Try
        System.Windows.Forms.Cursor.Current = Cursors.Arrow
        UseWaitCursor = False
    End Sub



    Private Sub OnDoublePulse(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _doublePulse.Click
        Dim dlg = New DlgDoublePulse

        dlg.PulseWidth = _strDoublePulseWidth
        dlg.PulseDelay = _strDoublePulseDelay

        If (dlg.ShowDialog() = DialogResult.OK) Then
            _strDoublePulseWidth = dlg.PulseWidth
            _strDoublePulseDelay = dlg.PulseDelay

        End If
    End Sub

    Private Sub OnTriggerMode(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim dlg = New DlgTrigger()

        dlg.Mode = _nTriggerMode
        dlg.Slope = _nTriggerSlope
        dlg.Polarity = _nTriggerPolarity

        If (dlg.ShowDialog() = DialogResult.OK) Then
            _nTriggerMode = dlg.Mode
            _nTriggerSlope = dlg.Slope
            _nTriggerPolarity = dlg.Polarity
        End If

    End Sub

    Private Sub OnDoublePulseStateClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _doublePulseState.Click
        _doublePulse.Enabled = _doublePulseState.Checked
    End Sub
End Class
